// SigPlusImagecppDlg.cpp : implementation file
//

//PLEASE NOTE!*******************************************
//Creating signature images is a fine way to display a 
//signature, but is not really recommended, because  
//the signer's biometric information and ability to encrypt  
//signatures gained by capturing using SigPlus is lost. 
//The ExportSigFile() method and/or GetSigString() return 
//a biometric signatur. For more details, contact the 
//Topaz tech support dept.at support@topazsystems.com
//*******************************************************

#include "stdafx.h"
#include "SigPlusImagecpp.h"
#include "SigPlusImagecppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSigPlusImagecppDlg dialog

CSigPlusImagecppDlg::CSigPlusImagecppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSigPlusImagecppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSigPlusImagecppDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSigPlusImagecppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSigPlusImagecppDlg)
	DDX_Control(pDX, IDC_SIGPLUSCTRL1, m_SigPlus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSigPlusImagecppDlg, CDialog)
	//{{AFX_MSG_MAP(CSigPlusImagecppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSigPlusImagecppDlg message handlers

BOOL CSigPlusImagecppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSigPlusImagecppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSigPlusImagecppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSigPlusImagecppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSigPlusImagecppDlg::OnOK() 
{
	// TODO: Add extra validation here
	m_SigPlus.SetTabletState(0);
	exit(0);
	CDialog::OnOK();
}

void CSigPlusImagecppDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	m_SigPlus.SetTabletState(0);
	exit(0);
	CDialog::OnCancel();
}

void CSigPlusImagecppDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	m_SigPlus.SetTabletState(1);
}

void CSigPlusImagecppDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	m_SigPlus.ClearTablet();
}

void CSigPlusImagecppDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	//*******************************************************
	//for simplicity's sake, this demo exposes only jpg.
	//however, SigPlus supports BMP and TIF as well.
	//use the SetImageFileFormat() to specify the file format:
	//0=bmp, 4=jpg, 6=tif
	//*******************************************************
	m_SigPlus.SetTabletState(0); //turn off tablet
	m_SigPlus.SetImageFileFormat(4); //jpg
	m_SigPlus.SetJustifyMode(5); //zoom signature
	m_SigPlus.SetImageXSize(500); //image width in px
	m_SigPlus.SetImageYSize(150); //image height in px
	m_SigPlus.SetImagePenWidth(9); //ink thickness in px

	CFileDialog dlg( FALSE,_T("JPG"),_T("*.JPG"),
                 OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
                 _T("Jpegs (*.JPG)|*.JPG|"));


if( dlg.DoModal()==IDOK )
	{

	CString	FileName;
    FileName = dlg.GetPathName();

	m_SigPlus.WriteImageFile( FileName ); //write image to location
	}
}

void CSigPlusImagecppDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	
    long            Size;
    long            i;
    unsigned char   ByteValue;
	CString	FileName;


	//*******************************************************
	//BMP only!
	//*******************************************************

	m_SigPlus.SetTabletState(0); //turn off tablet
	m_SigPlus.SetImageFileFormat(0); //bmp
	m_SigPlus.SetJustifyMode(5); //zoom signature
	m_SigPlus.SetImageXSize(500); //image width in px
	m_SigPlus.SetImageYSize(150); //image height in px
	m_SigPlus.SetImagePenWidth(9); //ink thickness in px

	CFileDialog dlg( FALSE,_T("BMP"),_T("*.BMP"),
          OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
          _T("Bmps (*.BMP)|*.BMP|"));


	if( dlg.DoModal()==IDOK )
	{
       FileName = dlg.GetPathName();
       FILE *OutputFile = fopen( FileName, "wb" );

        if ( OutputFile != NULL )
           {
           m_SigPlus.BitMapBufferWrite();
           Size = m_SigPlus.BitMapBufferSize();
           for( i = 0; i < Size; i++ )
                   {
                   ByteValue = (unsigned char)m_SigPlus.BitMapBufferByte( i );
                   fwrite( &ByteValue, 1, 1, OutputFile );
                   }
           fclose( OutputFile );
           m_SigPlus.BitMapBufferClose();
           }

	}

}
